#ifndef VERSION_H
#define VERSION_H

/*#include "webs.h"*/
#include "lang.h"

#define PATHNAME_CFG "/tmp/firmwareCfg"
#define PATHNAME_IMAGE "/tmp/image.chk"
#define PATHNAME_STRDAT "/tmp/stringtable.dat"/* Foxconn add by James, 02/27/2009 */

#define CHK_HEADER 58 /* Foxconn added by Caelia Su 2011/05/04 */

#define TRUE 1
#define FALSE 0

#define OK 1
#define ERROR 0

/* Foxconn added start by Caelia Su 2011/05/03 */
/* Firmeware version difference */
#define UNDEFINED 0
#define OLDER 1
#define SAME  2
#define NEWER 3
#define NA2WW 4
#define WW2NA 5

/* Region(same with bd_utility.h) */
#define NA_REGION 1
#define WW_REGION 2
#define GR_REGION 3
#define PR_REGION 4
#define RU_REGION 5
#define BZ_REGION 6
#define IN_REGION 7
#define KO_REGION 8
#define JP_REGION 9
/* Foxconn added end by Caelia Su 2011/05/03 */

// Status: get config file
#define FTPC_STATUS_CFG_NONE                0x00
#define FTPC_STATUS_CFG_IN_PROGRESS         0x01
#define FTPC_STATUS_CFG_IN_PROGRESS2        0x02
#define FTPC_STATUS_CFG_IN_PROGRESS3        0x03
#define FTPC_STATUS_CFG_NO_MEMORY           0x04
#define FTPC_STATUS_CFG_GET_FAIL            0x05
#define FTPC_STATUS_CFG_INVALID             0x06
#define FTPC_STATUS_CFG_OK                  0x07
#define FTPC_STATUS_CFG_ABORT_BY_USER       0x08
#define FTPC_STATUS_CFG_CANNOT_CONNECT_SVR  0x09
#define FTPC_STATUS_CFG_FILE_UNAVAILABLE    0x0b
#define FTPC_STATUS_CFG_FILE_SIZE_INCORRECT 0x0c
#define FTPC_STATUS_CFG_OTHER 0x0f

// Status: get image file
#define FTPC_STATUS_IMG_NONE                0x10
#define FTPC_STATUS_IMG_IN_PROGRESS         0x11
#define FTPC_STATUS_IMG_NO_MEMORY           0x14
#define FTPC_STATUS_IMG_GET_FAIL            0x15
#define FTPC_STATUS_IMG_INVALID             0x16
#define FTPC_STATUS_IMG_OK                  0x17
#define FTPC_STATUS_IMG_ABORT_BY_USER       0x18
#define FTPC_STATUS_IMG_CANNOT_CONNECT_SVR  0x19
#define FTPC_STATUS_IMG_LOGIN_FAIL          0x1a
#define FTPC_STATUS_IMG_FILE_UNAVAILABLE    0x1b
#define FTPC_STATUS_IMG_FILE_SIZE_INCORRECT 0x1c
#define FTPC_STATUS_INTOTO_IMG_OK           0x1d
#define FTPC_STATUS_IMG_OTHER 0x1f/* foxconn modified, zacker, 04/21/2010 */

//Status: write image to flash
#define FTPC_STATUS_WRITE_IMG_NONE          0x40
#define FTPC_STATUS_WRITE_IMG_IN_PROGRESS   0x41
#define FTPC_STATUS_WRITE_IMG_FAIL          0x42
#define FTPC_STATUS_WRITE_IMG_OK            0x43

// FTP error code
#define FTPC_ERR_NONE               0xf0
#define FTPC_ERR_DNS_RESOLER_UPDATE 0xf1
#define FTPC_ERR_DNS_RESOLE_FAIL    0xf2
#define FTPC_ERR_HOOKUP_FAIL        0xf3
#define FTPC_ERR_LOGIN_FAIL         0xf4
#define FTPC_ERR_GET_FILE_FAIL      0xf5
#define FTPC_ERR_BUFFER_OVERFLOW    0xf6
#define FTPC_ERR_ABORT_BY_USER      0xf7
#define FTPC_ERR_READ_TIMEOUT       0xf8
#define FTPC_ERR_FILE_UNAVAILABLE   0xf9
#define FTPC_ERR_OTHERS             0xfa

#define FTPC_GET_NONE 0x33e0
#define FTPC_GET_STRDAT 0x33e3
#define FTPC_GET_CFG 0x33e1
#define FTPC_GET_IMAGE 0x33e2

#define VER_FOUND 1
#define VER_NOT_FOUND 2

#define FTP_CHECK_FW 1
#define FTP_CHECK_LANG 2

#define MAX_PRODUCT_NAME_LEN 192
#define MAX_BOARDID_LEN 64
#define MAX_FILENAME_LEN 192
#define MAX_HOSTNAME_LEN 64

#define SIZE_CFGFILE (12*1024)
#define SIZE_STRTBL_DAT (8*1024)

#ifdef SAMBA_ENABLE 
#define MAX_IMAGE_SIZE          7488*1024    /* For 8M flash */
#else
#define MAX_IMAGE_SIZE          3392*1024    /* For 4M flash */
#endif

#if (defined SAMBA_ENABLE)
#ifndef WNR3500L
#define MAX_SIZE_FILE 8*1024*1024
#define MAX_SIZE_KERNEL 8*1024*1024
#endif
#else
#define MAX_SIZE_FILE 4*1024*1024   /* For AP71, this is 4M flash */
#define MAX_SIZE_KERNEL 4*1024*1024
#endif

#define MAX_SIZE_ROOTFS MAX_SIZE_FILE

#define FIELD_LEN_SIZE          4
#define FIELD_CHK_SIZE          4
#define FILES_CHKLEN_SIZE       4
#define IMAGE_BLOCK_SIZE        0x10000

#define C_MAX_VAR_SIZE 256
#define MAX_BYTE_PER_LINE                           512

#define KERNEL_MTD_WR "/dev/mtd1"
#define ROOTFS_MTD_WR "/dev/mtd2"
#define TMP_UPGRADE_FILE "/tmp/upgrade.tmp"

#define HTMLTAG_NOTES       "<p><tr><td colspan=2>&nbsp;%d. &nbsp %s </td></tr></p>"

#define A_TOLOWER(c) (((c) >= 'A' && (c) <='Z') ? ((c) -'A'+'a') : (c))

#ifndef isspace
#define isspace(c)      ((c) == ' ')
#endif

#ifndef islf
#define islf(c) ((c) == '\n')
#endif

#ifndef iscr
#define iscr(c) ((c) == '\r')
#endif

typedef struct LatestFwVersionInfo_s{
    char boardID[MAX_BOARDID_LEN];
    char filename[MAX_FILENAME_LEN];
    char host[MAX_HOSTNAME_LEN];
    unsigned int fileSize;
}LatestFwVersionInfo_t;

typedef struct ImageInfo
{
    unsigned long kernelSize;
    unsigned long rootfsSize;
    unsigned long kernelChksum;
    unsigned long rootfsChksum;
    unsigned long chksum;
}ImageInfo_s;

unsigned char newFwVersion[20];
//unsigned char fwVersion[50];
extern int abCheckBoardID (unsigned char *startPtr, unsigned int size);
extern int verComp(unsigned char *startPtr, unsigned int size);
int create_upgrade_file(void);
int ftpc_Abort (void);
static int ftpc_GetError (int errorCode);
void ftpc_GotFile (void);
static int ftpc_ReadErrorCode (void);
void ftpc_SendGetStrDatCmd(int ftpcStatus);
void ftpc_SendGetCfgCmd (int serverIndex, int ftpcStatus);
void ftpc_SendGetImageCmd (LatestFwVersionInfo_t * fwVersionInfo);
int ftpc_GetConfigFileStatus(LatestFwVersionInfo_t *pFwVerInfo, LatestLangTblVersionInfo_t *plangTblVerInfo);
int ftpc_GetImageFileStatus (void);
int ftpc_WriteImgToFlash (void);
int calculateFileSize(FILE *fd, unsigned long *size);
static unsigned long calculate_checksum (int action, char *s, int size);
void latestFwVersionInfo_Reset2Default (LatestFwVersionInfo_t *pFwVerInfo);
int isFwLatest (LatestFwVersionInfo_t * fwVersionInfo);
static int isBlankLine (char *pStr);
static int ver_CheckChecksum (FILE *fp);
static int ver_GetFwVersion (LatestFwVersionInfo_t * fwVersionInfo, char *version);
static unsigned int ver_getkernelSize (void);
static unsigned int ver_getrootfsSize (void);
static unsigned int ver_getImageSize (void);
static unsigned int getImageChksum (void);
static unsigned long ver_getKernelChksum(void);
static unsigned long ver_getRootfsChksum(void);
int ver_SetImageInfo (ImageInfo_s * imageInfo);
static int ver_ReadImgInfo (char *buf);
static char *parseBoardId (char *pStr, char *boardID);
static char *parseFileName (char *pStr);
static char *parseFileSize(char *pStr);
static int parseFileMD5(char *pStr, char *fileMD5, unsigned long strsize);
int parseLatestFwVersionInfo (char *dataBuf,
                              LatestFwVersionInfo_t * pFwVerInfo,
                              unsigned int dataLen);
int stricmp(char *str1, char* str2);
char *stristr (const char *a, const char *b);
int unicode_file_to_ascii_str(unsigned char *asciibuf,
                              unsigned int asciibufsize,
                              unsigned char *unicodebuf,
                              unsigned int unicodebufsize);
int verGetNotes(unsigned char *tmpBuf);
static int writeXndmtd
(
    char *mtdFileName, 
    FILE *fp, 
    unsigned int imageSize,
    unsigned long checksum
);

#endif
